## ebtables 2.0.10.4-3-cl4.3.1u4

=== Makefile ===
# ebtables Makefile

PROGNAME:=ebtables
PROGRELEASE:=4
PROGVERSION_:=2.0.10
PROGVERSION:=$(PROGVERSION_)-$(PROGRELEASE)
PROGDATE:=December\ 2011
LOCKFILE?=/var/lib/ebtables/lock
LOCKDIR:=$(shell echo $(LOCKFILE) | sed 's/\(.*\)\/.*/\1/')/

# default paths
LIBDIR:=/usr/lib
MANDIR:=/usr/share/man
BINDIR:=/sbin
ETCDIR:=/etc
INITDIR:=/etc/init.d
SYSCONFIGDIR:=/etc/default
DESTDIR:=

CFLAGS:=-Wall -Wunused -Werror
CFLAGS_SH_LIB:=-fPIC -O3
CC:=gcc

ifeq ($(shell uname -m),sparc64)
CFLAGS+=-DEBT_MIN_ALIGN=8 -DKERNEL_64_USERSPACE_32
endif

include extensions/Makefile

OBJECTS2:=getethertype.o communication.o libebtc.o \
useful_functions.o ebtables.o

OBJECTS:=$(OBJECTS2) $(EXT_OBJS) $(EXT_LIBS)

KERNEL_INCLUDES?=include/

ETHERTYPESPATH?=$(ETCDIR)
ETHERTYPESFILE:=$(ETHERTYPESPATH)/ethertypes

PIPE_DIR?=/tmp/$(PROGNAME)-v$(PROGVERSION)
PIPE=$(PIPE_DIR)/ebtablesd_pipe
EBTD_CMDLINE_MAXLN?=2048
EBTD_ARGC_MAX?=50

PROGSPECS:=-DPROGVERSION=\"$(PROGVERSION)\" \
	-DPROGNAME=\"$(PROGNAME)\" \
	-DPROGDATE=\"$(PROGDATE)\" \
	-D_PATH_ETHERTYPES=\"$(ETHERTYPESFILE)\" \
	-DEBTD_ARGC_MAX=$(EBTD_ARGC_MAX) \
	-DEBTD_CMDLINE_MAXLN=$(EBTD_CMDLINE_MAXLN) \
	-DLOCKFILE=\"$(LOCKFILE)\" \
	-DLOCKDIR=\"$(LOCKDIR)\"

# You can probably ignore this, ebtables{u,d} are normally not used
PROGSPECSD:=-DPROGVERSION=\"$(PROGVERSION)\" \
	-DPROGNAME=\"$(PROGNAME)\" \
	-DPROGDATE=\"$(PROGDATE)\" \
	-D_PATH_ETHERTYPES=\"$(ETHERTYPESFILE)\" \
	-DEBTD_CMDLINE_MAXLN=$(EBTD_CMDLINE_MAXLN) \
	-DEBTD_ARGC_MAX=$(EBTD_ARGC_MAX) \
	-DEBTD_PIPE=\"$(PIPE)\" \
	-DEBTD_PIPE_DIR=\"$(PIPE_DIR)\"

# Uncomment for debugging (slower)
#PROGSPECS+=-DEBT_DEBUG
#PROGSPECSD+=-DEBT_DEBUG
#CFLAGS+=-ggdb

all: ebtables ebtables-restore

communication.o: communication.c include/ebtables_u.h
	$(CC) $(CFLAGS) $(CFLAGS_SH_LIB) $(PROGSPECS) -c -o $@ $< -I$(KERNEL_INCLUDES)

libebtc.o: libebtc.c include/ebtables_u.h
	$(CC) $(CFLAGS) $(CFLAGS_SH_LIB) $(PROGSPECS) -c -o $@ $< -I$(KERNEL_INCLUDES)

useful_functions.o: useful_functions.c include/ebtables_u.h
	$(CC) $(CFLAGS) $(CFLAGS_SH_LIB) $(PROGSPECS) -c -o $@ $< -I$(KERNEL_INCLUDES)

getethertype.o: getethertype.c include/ethernetdb.h
	$(CC) $(CFLAGS) $(CFLAGS_SH_LIB) $(PROGSPECS) -c -o $@ $< -Iinclude/

ebtables.o: ebtables.c include/ebtables_u.h
	$(CC) $(CFLAGS) $(CFLAGS_SH_LIB) $(PROGSPECS) -c -o $@ $< -I$(KERNEL_INCLUDES)

ebtables-standalone.o: ebtables-standalone.c include/ebtables_u.h
	$(CC) $(CFLAGS) $(CFLAGS_SH_LIB) $(PROGSPECS) -c $< -o $@ -I$(KERNEL_INCLUDES)

libebtc.so: $(OBJECTS2)
	$(CC) -shared $(LDFLAGS) -Wl,-soname,libebtc.so -o libebtc.so -lc $(OBJECTS2)

ebtables: $(OBJECTS) ebtables-standalone.o libebtc.so
	$(CC) $(CFLAGS) $(CFLAGS_SH_LIB) $(LDFLAGS) -o $@ ebtables-standalone.o -I$(KERNEL_INCLUDES) -L. -Lextensions -lebtc $(EXT_LIBSI) \
	-Wl,-rpath,$(LIBDIR)

ebtablesu: ebtablesu.c
	$(CC) $(CFLAGS) $(PROGSPECSD) $< -o $@

ebtablesd.o: ebtablesd.c include/ebtables_u.h
	$(CC) $(CFLAGS) $(PROGSPECSD) -c $< -o $@  -I$(KERNEL_INCLUDES)

ebtablesd: $(OBJECTS) ebtablesd.o libebtc.so
	$(CC) $(CFLAGS) -o $@ ebtablesd.o -I$(KERNEL_INCLUDES) -L. -Lextensions -lebtc $(EXT_LIBSI) \
	-Wl,-rpath,$(LIBDIR)

ebtables-restore.o: ebtables-restore.c include/ebtables_u.h
	$(CC) $(CFLAGS) $(PROGSPECS) -c $< -o $@  -I$(KERNEL_INCLUDES)

ebtables-restore: $(OBJECTS) ebtables-restore.o libebtc.so
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ ebtables-restore.o -I$(KERNEL_INCLUDES) -L. -Lextensions -lebtc $(EXT_LIBSI) \
	-Wl,-rpath,$(LIBDIR)

.PHONY: daemon
daemon: ebtablesd ebtablesu

# a little scripting for a static binary, making one for ebtables-restore
# should be completely analogous
static: extensions/ebt_*.c extensions/ebtable_*.c ebtables.c communication.c ebtables-standalone.c getethertype.c libebtc.c useful_functions.c
	cp ebtables-standalone.c ebtables-standalone.c_ ; \
	cp include/ebtables_u.h include/ebtables_u.h_ ; \
	sed "s/ main(/ pseudomain(/" ebtables-standalone.c > ebtables-standalone.c__ ; \
	mv ebtables-standalone.c__ ebtables-standalone.c ; \
	printf "\nint main(int argc, char *argv[])\n{\n "  >> ebtables-standalone.c ; \
	for arg in $(EXT_FUNC) \
	; do \
	sed s/_init/_$${arg}_init/ extensions/ebt_$${arg}.c > extensions/ebt_$${arg}.c_ ; \
	mv extensions/ebt_$${arg}.c_ extensions/ebt_$${arg}.c ; \
	printf "\t%s();\n" _$${arg}_init >> ebtables-standalone.c ; \
	printf "extern void %s();\n" _$${arg}_init >> include/ebtables_u.h ; \
	done ; \
	for arg in $(EXT_TABLES) \
	; do \
	sed s/_init/_t_$${arg}_init/ extensions/ebtable_$${arg}.c > extensions/ebtable_$${arg}.c_ ; \
	mv extensions/ebtable_$${arg}.c_ extensions/ebtable_$${arg}.c ; \
	printf "\t%s();\n" _t_$${arg}_init >> ebtables-standalone.c ; \
	printf "extern void %s();\n" _t_$${arg}_init >> include/ebtables_u.h ; \
	done ; \
	printf "\n\tpseudomain(argc, argv);\n\treturn 0;\n}\n" >> ebtables-standalone.c ;\
	$(CC) $(CFLAGS) $(LDFLAGS) $(PROGSPECS) -o $@ $^ -I$(KERNEL_INCLUDES) -Iinclude ; \
	for arg in $(EXT_FUNC) \
	; do \
	sed "s/ .*_init/ _init/" extensions/ebt_$${arg}.c > extensions/ebt_$${arg}.c_ ; \
	mv extensions/ebt_$${arg}.c_ extensions/ebt_$${arg}.c ; \
	done ; \
	for arg in $(EXT_TABLES) \
	; do \
	sed "s/ .*_init/ _init/" extensions/ebtable_$${arg}.c > extensions/ebtable_$${arg}.c_ ; \
	mv extensions/ebtable_$${arg}.c_ extensions/ebtable_$${arg}.c ; \
	done ; \
	mv ebtables-standalone.c_ ebtables-standalone.c ; \
	mv include/ebtables_u.h_ include/ebtables_u.h

tmp1:=$(shell printf $(BINDIR) | sed 's/\//\\\//g')
tmp2:=$(shell printf $(SYSCONFIGDIR) | sed 's/\//\\\//g')
tmp3:=$(shell printf $(PIPE) | sed 's/\//\\\//g')
.PHONY: scripts
scripts: ebtables-save ebtables.sysv ebtables-config
	cat ebtables-save | sed 's/__EXEC_PATH__/$(tmp1)/g' > ebtables-save_
	mkdir -p $(DESTDIR)$(BINDIR)
	cat ebtables.sysv | sed 's/__EXEC_PATH__/$(tmp1)/g' | sed 's/__SYSCONFIG__/$(tmp2)/g' > ebtables.sysv_
	if [ "$(DESTDIR)" != "" ]; then mkdir -p $(DESTDIR)$(INITDIR); fi
	cat ebtables-config | sed 's/__SYSCONFIG__/$(tmp2)/g' > ebtables-config_
	if [ "$(DESTDIR)" != "" ]; then mkdir -p $(DESTDIR)$(SYSCONFIGDIR); fi

tmp4:=$(shell printf $(LOCKFILE) | sed 's/\//\\\//g')
$(MANDIR)/man8/ebtables.8: ebtables.8
	sed -e 's/$$(VERSION)/$(PROGVERSION)/' -e 's/$$(DATE)/$(PROGDATE)/' -e 's/$$(LOCKFILE)/$(tmp4)/' ebtables.8 > ebtables.8_

$(DESTDIR)$(ETHERTYPESFILE): ethertypes
	mkdir -p $(@D)
	install -m 0644 -o root -g root $< $@

.PHONY: exec
exec: ebtables ebtables-restore
	mkdir -p $(DESTDIR)$(LIBDIR) $(DESTDIR)$(INITDIR) $(DESTDIR)$(SYSCONFIGDIR) $(DESTDIR)$(MANDIR)/man8
	install -m 0755 -o root -g root $(PROGNAME) $(DESTDIR)$(BINDIR)
	install -m 0755 -o root -g root ebtables-restore $(DESTDIR)$(BINDIR)/ebtables-restore
	install -m 0755 -o root -g root ebtables-save_ $(DESTDIR)$(BINDIR)/ebtables-save
#	install -m 0755 -o root -g root ebtables.sysv_ $(DESTDIR)$(INITDIR)/ebtables
	install -m 0600 -o root -g root ebtables-config_ $(DESTDIR)$(SYSCONFIGDIR)/ebtables-config
	install -m 0644 -o root -g root ebtables.8_ $(DESTDIR)$(MANDIR)/man8/ebtables.8

.PHONY: install
install: $(MANDIR)/man8/ebtables.8 $(DESTDIR)$(ETHERTYPESFILE) scripts exec
	mkdir -p $(DESTDIR)$(LIBDIR)
	install -m 0755 extensions/*.so $(DESTDIR)$(LIBDIR)
	install -m 0755 *.so $(DESTDIR)$(LIBDIR)

.PHONY: clean
clean:
	rm -f ebtables ebtables-restore ebtablesd ebtablesu static
	rm -f *.o *~ *.so
	rm -f extensions/*.o extensions/*.c~ extensions/*.so include/*~

DIR:=$(PROGNAME)-v$(PROGVERSION)
CVSDIRS:=CVS extensions/CVS examples/CVS examples/perf_test/CVS \
examples/ulog/CVS include/CVS
# This is used to make a new userspace release, some files are altered so
# do this on a temporary version
.PHONY: release
release:
	rm -f extensions/ebt_inat.c
	rm -rf $(CVSDIRS)
	mkdir -p include/linux/netfilter_bridge
	install -m 0644 -o root -g root \
		$(KERNEL_INCLUDES)/linux/netfilter_bridge.h include/linux/
# To keep possible compile error complaints about undefined ETH_P_8021Q
# off my back
	install -m 0644 -o root -g root \
		$(KERNEL_INCLUDES)/linux/if_ether.h include/linux/
	install -m 0644 -o root -g root \
		$(KERNEL_INCLUDES)/linux/types.h include/linux/
	install -m 0644 -o root -g root \
		$(KERNEL_INCLUDES)/linux/netfilter_bridge/*.h \
		include/linux/netfilter_bridge/
	install -m 0644 -o root -g root \
		include/ebtables.h include/linux/netfilter_bridge/
	make clean
	touch *
	touch extensions/*
	touch include/*
	touch include/linux/*
	touch include/linux/netfilter_bridge/*
	sed -i -e 's/$$(VERSION)/$(PROGVERSION)/' -e 's/$$(DATE)/$(PROGDATE)/' -e 's/$$(LOCKFILE)/$(tmp4)/' ebtables.8
	sed -i -e 's/$$(VERSION)/$(PROGVERSION_)/' -e 's/$$(RELEASE)/$(PROGRELEASE)/' ebtables.spec
	cd ..;tar -c $(DIR) | gzip >$(DIR).tar.gz; cd -
	rm -rf include/linux

# This will make the rpm and put it in /usr/src/redhat/RPMS
# (do this as root after make release)
.PHONY: rpmbuild
rpmbuild:
	cp ../$(DIR).tar.gz /usr/src/redhat/SOURCES/
	rpmbuild --buildroot $(shell mktemp -td $(DIR)-XXXXX) -bb ebtables.spec

.PHONY: test_ulog
test_ulog: examples/ulog/test_ulog.c getethertype.o
	$(CC) $(CFLAGS)  $< -o test_ulog -I$(KERNEL_INCLUDES) -lc \
	getethertype.o
	mv test_ulog examples/ulog/

.PHONY: examples
examples: test_ulog

=== extensions/Makefile ===
#! /usr/bin/make

EXT_FUNC+=802_3 nat arp arpreply ip ip6 standard log redirect vlan mark_m mark \
          pkttype stp among limit ulog nflog erspan span police tricolorpolice setclass setqos
EXT_TABLES+=filter nat broute
EXT_OBJS+=$(foreach T,$(EXT_FUNC), extensions/ebt_$(T).o)
EXT_OBJS+=$(foreach T,$(EXT_TABLES), extensions/ebtable_$(T).o)
EXT_LIBS+=$(foreach T,$(EXT_FUNC), extensions/libebt_$(T).so)
EXT_LIBS+=$(foreach T,$(EXT_TABLES), extensions/libebtable_$(T).so)
EXT_LIBSI+=$(foreach T,$(EXT_FUNC), -lebt_$(T))
EXT_LIBSI+=$(foreach T,$(EXT_TABLES), -lebtable_$(T))

extensions/ebt_%.so: extensions/ebt_%.o
	$(CC) $(LDFLAGS) -shared -o $@ -lc $< -nostartfiles

extensions/libebt_%.so: extensions/ebt_%.so
	mv $< $@

extensions/ebtable_%.so: extensions/ebtable_%.o
	$(CC) $(LDFLAGS) -shared -o $@ -lc $< -nostartfiles

extensions/libebtable_%.so: extensions/ebtable_%.so
	mv $< $@

extensions/ebt_%.o: extensions/ebt_%.c include/ebtables_u.h
	$(CC) $(CFLAGS) $(CFLAGS_SH_LIB) $(PROGSPECS) -c -o $@ $< -I$(KERNEL_INCLUDES)

extensions/ebtable_%.o: extensions/ebtable_%.c
	$(CC) $(CFLAGS) $(CFLAGS_SH_LIB) $(PROGSPECS) -c -o $@ $< -I$(KERNEL_INCLUDES)

=== debian/changelog ===
ebtables (2.0.10.4-3-cl4.3.1u4) RELEASED; urgency=medium

  * new build for 4.3.1 from original hash
    962f5808484bcabf7ec4e02fac65e7183701373e

 -- root <root@3da22e72fb7c>  Tue, 14 Jun 2022 19:40:48 +0000

ebtables (2.0.10.4-3-cl4u1) RELEASED; urgency=high

  * Initial changelog entry for cl4

 -- dev-support <dev-support@cumulusnetworks.com>  Tue, 05 Feb 2019 15:27:13 -0800

ebtables (2.0.10.4-3-cl3u4) RELEASED; urgency=medium

  * Add copyright for cumulus modified code in ebtables since 2013

 -- dev-support <dev-support@cumulusnetworks.com>  Wed, 11 Apr 2018 13:03:53 -0700

ebtables (2.0.10.4-3-cl3u3) RELEASED; urgency=medium

  * Remove "Breaks" from debian/control

 -- Balki Raman <ramanb@monster-08>  Fri, 19 Aug 2016 16:02:10 -0700

ebtables (2.0.10.4-3-cl3u2) RELEASED; urgency=medium

  * Added SETQOS support

 -- dev-support <dev-support@cumulusnetworks.com>  Fri, 24 Jun 2016 09:22:51 -0700

ebtables (2.0.10.4-3-cl3u1) RELEASED; urgency=medium

  * Initial CumulusLinux 3 release.

 -- dev-support <dev-support@cumulusnetworks.com>  Mon, 09 May 2016 09:22:51 -0700

=== debian/control ===
Source: ebtables
Section: net
Priority: optional
Maintainer: Jochen Friedrich <jochen@scram.de>
Uploaders: William Dauchy <wdauchy@gmail.com>
Standards-Version: 3.9.3
Build-Depends: debhelper (>= 9), cdbs, git
Homepage: http://ebtables.sourceforge.net
XS-Build-Source: True
XS-Cumulus-Valid-Arch: amd64 armel
XBCS-Vcs-Hash: 962f5808484bcabf7ec4e02fac65e7183701373e

Package: ebtables
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: iptables, kmod
Description: Ethernet bridge frame table administration
 Ebtables is used to set up, maintain, and inspect the tables of 
 Ethernet frame rules in the Linux kernel. It is analogous to iptables, 
 but operates at the MAC layer rather than the IP layer.
XBCS-Vcs-Hash: 962f5808484bcabf7ec4e02fac65e7183701373e

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_HARDENING = 1
MAKE_PATH_REDIRECTIONS:=LIBDIR=/lib/ebtables \
			BINDIR=/sbin \
			DESTDIR=debian/ebtables

include /usr/share/cdbs/1/rules/debhelper.mk

CFLAGS+=$(HARDENING_CFLAGS) -fstack-protector-all
LDFLAGS+=$(HARDENING_LDFLAGS)

#DEB_DH_INSTALLINIT_ARGS:=-- start 20 S . stop 80 0 1 6 .

build/ebtables::
	make CFLAGS="$(CFLAGS)" $(MAKE_PATH_REDIRECTIONS)

clean::
	dh_testdir
	rm -f build-stamp
	make clean
	rm -f ebtables.8_ ebtables.sysv_ ebtables-config_ ebtables-save_
	dh_clean

install/ebtables:: build
	dh_testdir
	dh_testroot
	dh_clean
	dh_installdirs
	make install $(MAKE_PATH_REDIRECTIONS)
	rm -f debian/ebtables/sbin/ebtables-save debian/ebtables/sbin/ebtables-restore
	#mv debian/ebtables/etc/default/ebtables-config debian/ebtables/etc/default/ebtables
	rm -f debian/ebtables/etc/init.d/ebtables
	rm -f debian/ebtables/etc/default/ebtables-config
	mkdir -p debian/ebtables/usr/share/lintian/overrides
	cp debian/ebtables.override debian/ebtables/usr/share/lintian/overrides/ebtables

## ebtables 2.0.11

=== debian/changelog ===
ebtables (2.0.11-4) unstable; urgency=medium

  [ Debian Janitor ]
  * [dd00d30] debian/copyright: use spaces rather than tabs to start
    continuation lines.
  * [0d18442] Use canonical URL in Vcs-Browser.
  * [5f86090] Fix day-of-week for changelog entry 2.0.10.4-2.
  * [5f0000d] Update standards version to 4.5.0, no changes needed.

  [ Alberto Molina Coballes ]
  * [c4a3f15] d/: add basic autopkgtests
  * [ea72fad] ebtables: bump debhelper-compat to 13

 -- Alberto Molina Coballes <alb.molina@gmail.com>  Fri, 05 Jun 2020 14:40:39 +0000

ebtables (2.0.11-3) unstable; urgency=medium

  * [5f984fe] d/control: add dependency upon netbase
  * [69c66a6] d/control: bump to debhelper-compat
  * [bcf3a58] d/control: Set 'Rules-Requires-Root: no'

 -- Alberto Molina Coballes <alb.molina@gmail.com>  Wed, 01 Jan 2020 20:16:29 +0000

ebtables (2.0.11-2) unstable; urgency=medium

  * [ad3fd35] d/patches: refresh makefile.patch

 -- Alberto Molina Coballes <alb.molina@gmail.com>  Thu, 19 Dec 2019 17:33:21 +0000

ebtables (2.0.11-1) unstable; urgency=medium

  * [7d9e79f] d/watch: update upstream url regexp
  * [4a2982c] New upstream version 2.0.11
  * [7d0f7db] d/control: bump std-version to 4.4.1
  * [059b40c] d/patches: upgrade patches to new upstream release
  * [2213ace] d/patches correct wrong sbindir in makefile.patch
  * [1c5080d] d/rules: override dh_makeshlibs

 -- Alberto Molina Coballes <alb.molina@gmail.com>  Fri, 06 Dec 2019 19:26:15 +0000

=== debian/control ===
Source: ebtables
Section: net
Priority: optional
Maintainer: Debian Netfilter Packaging Team <pkg-netfilter-team@lists.alioth.debian.org>
Uploaders: Alberto Molina Coballes <alb.molina@gmail.com>
Standards-Version: 4.5.0
Build-Depends: debhelper-compat (= 13)
Rules-Requires-Root: no
Homepage: https://netfilter.org/
Vcs-Git: https://salsa.debian.org/pkg-netfilter-team/pkg-ebtables.git
Vcs-Browser: https://salsa.debian.org/pkg-netfilter-team/pkg-ebtables

Package: ebtables
Architecture: linux-any
Multi-Arch: foreign
Depends: netbase (>= 6.0), ${shlibs:Depends}, ${misc:Depends}
Recommends: iptables, kmod
Description: Ethernet bridge frame table administration
 Ebtables is used to set up, maintain, and inspect the tables of
 Ethernet frame rules in the Linux kernel. It is analogous to iptables,
 but operates at the MAC layer rather than the IP layer.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

override_dh_makeshlibs:
	dh_makeshlibs -n

%:
	dh $@

=== debian/tests/control ===
Test-Command: ebtables-legacy -h
Depends: @
Restrictions: needs-root

Test-Command: ebtables-legacy-save
Depends: @
Restrictions: needs-root, isolation-container

Test-Command: ebtablesu -h
Depends: @
Restrictions: needs-root

=== debian/watch ===
version=4
http://ftp.netfilter.org/pub/ebtables/ebtables-v?([\.\d]+).tar.gz
